// physicalfile.cpp: implementation of the CPhysicalFile class.
//
//////////////////////////////////////////////////////////////////////


#include "physicalfile.h"

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////


namespace FileSystem
{
CResult CPhysicalFile::initialize(CDataManager* pManager,char* fileName)
{
	CResult result = Inherit::initialize(pManager);

	//init vars
	isOpen = false;
	fileHandle = NULL;
	
	//if all is ok
	if ( result == resultOk)
	{	
		//open file
		fileHandle = fopen(fileName,"rb");

		//if file dosen't open, report and error, else, se that file is open
		if (fileHandle==NULL)
			result = CResult(codeFail,0,"Couldn't open file");
		else
			isOpen = true;
	}

	//return result
	return result;
}

CResult CPhysicalFile::finalize()
{

	CResult result = CDataFile::finalize();

	//if file was open, close it
	if (isOpen)
		fclose(fileHandle);

	//is no more open
	isOpen = false;

	return result;

}


int CPhysicalFile::seek(long amount,int pos)
{
	//just seek
	return fseek(fileHandle,amount,pos);	
}

int CPhysicalFile::read(long amount,char* buffer)
{
	//just read
	return fread(buffer,1,amount,fileHandle);
}

int CPhysicalFile::eof()
{
	//just check eof
	return feof(fileHandle);
}

char* CPhysicalFile::gets(char* buffer,int maxLen)
{
	//just fgets
	return fgets(buffer,maxLen,fileHandle);
}

}

