// Test.cpp : Defines the entry point for the console application.
//

#include "stdafx.h"

#include <DataManager.h>
#include <stdio.h>
#include <stdlib.h>
#include <stdarg.h>
#include <conio.h>

bool DumpTxtFileNOOP(const char* sPath)
{
	
	bool result = true;

	FSFILE* file = fsopen(sPath);
	
	printf("\nDump text file \"%s\"\n",sPath);
	
	if ( file != NULL)
	{
		
		printf("---------------------------------------------------------\n");

		char sbuf[1024];		
		while(!fseof(file))
		{
			ZeroMemory(sbuf,1024);
			if (fsread(1024,sbuf,file) > 0)
			{
				printf(sbuf);
			}			
		}

		fsclose(file);

		printf("\n---------------------------------------------------------\n");
	}
	else
	{
		printf("Error open file\n");
		result = false;
	}

	return result;
}

bool DumpTxtFileOOP(FileSystem::CDataManager* pManager, const char* sPath)
{
	
	FileSystem::CResult result=FileSystem::resultOk;

	FileSystem::CDataFile* pFile = pManager->openFile(sPath);

	printf("\nDump text file \"%s\"\n",sPath);
	
	if ( pFile != NULL)
	{
		
		printf("---------------------------------------------------------\n");

		char sbuf[1024];		
		while(!pFile->eof())
		{
			ZeroMemory(sbuf,1024);
			if (pFile->read(1024,sbuf) > 0)
			{
				printf(sbuf);
			}			
		}

		pManager->closeFile(pFile);

		printf("\n---------------------------------------------------------\n");
	}
	else
	{
		printf("Error open file %s\n",result.string);
	}

	return (result==FileSystem::resultOk);
}

void NOOP()
{
	printf("No Object oriented programing test\n");

	if (InitFS("..\\..\\data\\") )
	{
		printf("Init file system\n");

		DumpTxtFileNOOP("txt\\xml\\Factory.txt");

		DumpTxtFileNOOP("txt\\zlib\\algorithm.txt");
	}
	else
	{
		printf("Error init file system\n");
	}
}

void OOP()
{
	printf("Object oriented programing test\n");

	FileSystem::CResult result;
	FileSystem::CDataManager DataManager;

	result = DataManager.initialize("..\\..\\data\\");

	if(result==FileSystem::resultOk)
	{	
		printf("Init data manager\n");


		DumpTxtFileOOP(&DataManager,"txt\\xml\\Factory.txt");

		DumpTxtFileOOP(&DataManager,"txt\\zlib\\algorithm.txt");

		DataManager.finalize();
	}
	else
	{
		printf("Error init data manager %s\n",result.string);
	}

}


int main(int argc, char* argv[])
{
	char choice[32];
		
	printf("Options:\n");
	printf("\n");
	printf("1. Object Oriented Programing Test\n");
	printf("2. No Object Oriented Programing Test\n");
	printf("\n");
	printf("Make your choice...:");

	scanf("%1s",choice);



	if (strcmp(choice,"1")==0)
	{
		OOP();
	}
	else
	{
		NOOP();
	}

	printf ("\n\npress a key to exit...\n");

	while(!kbhit() );

	return 0;
}





















